
;CodeVisionAVR C Compiler V2.05.3 Standard
;(C) Copyright 1998-2011 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type                : ATmega32
;Program type             : Application
;Clock frequency          : 8.000000 MHz
;Memory model             : Small
;Optimize for             : Size
;(s)printf features       : int, width
;(s)scanf features        : int, width
;External RAM size        : 0
;Data Stack size          : 512 byte(s)
;Heap size                : 0 byte(s)
;Promote 'char' to 'int'  : Yes
;'char' is unsigned       : Yes
;8 bit enums              : Yes
;Global 'const' stored in FLASH     : No
;Enhanced function parameter passing: Yes
;Enhanced core instructions         : On
;Smart register allocation          : On
;Automatic register allocation      : On

	#pragma AVRPART ADMIN PART_NAME ATmega32
	#pragma AVRPART MEMORY PROG_FLASH 32768
	#pragma AVRPART MEMORY EEPROM 1024
	#pragma AVRPART MEMORY INT_SRAM SIZE 2143
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x60

	#define CALL_SUPPORTED 1

	.LISTMAC
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU GICR=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __SRAM_START=0x0060
	.EQU __SRAM_END=0x085F
	.EQU __DSTACK_SIZE=0x0200
	.EQU __HEAP_SIZE=0x0000
	.EQU __CLEAR_SRAM_SIZE=__SRAM_END-__SRAM_START+1

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ANDI R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ANDD2N
	ANDI R26,LOW(@0)
	ANDI R27,HIGH(@0)
	ANDI R24,BYTE3(@0)
	ANDI R25,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ORI  R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD2N
	ORI  R26,LOW(@0)
	ORI  R27,HIGH(@0)
	ORI  R24,BYTE3(@0)
	ORI  R25,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __CLRD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+(@1))
	LDI  R31,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	LDI  R22,BYTE3(2*@0+(@1))
	LDI  R23,BYTE4(2*@0+(@1))
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTW2FN
	LDI  R26,LOW(2*@0+(@1))
	LDI  R27,HIGH(2*@0+(@1))
	.ENDM

	.MACRO __POINTD2FN
	LDI  R26,LOW(2*@0+(@1))
	LDI  R27,HIGH(2*@0+(@1))
	LDI  R24,BYTE3(2*@0+(@1))
	LDI  R25,BYTE4(2*@0+(@1))
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+(@2))
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+(@3))
	LDI  R@1,HIGH(@2+(@3))
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+(@3))
	LDI  R@1,HIGH(@2*2+(@3))
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+(@1)
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+(@1)
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	LDS  R22,@0+(@1)+2
	LDS  R23,@0+(@1)+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+(@2)
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+(@3)
	LDS  R@1,@2+(@3)+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+(@1)
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	LDS  R24,@0+(@1)+2
	LDS  R25,@0+(@1)+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+(@1),R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	STS  @0+(@1)+2,R22
	STS  @0+(@1)+3,R23
	.ENDM

	.MACRO __PUTB1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMWRB
	.ENDM

	.MACRO __PUTW1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMWRW
	.ENDM

	.MACRO __PUTD1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMWRD
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+(@1),R0
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+(@1),R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+(@1),R@2
	STS  @0+(@1)+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTBSR
	STD  Y+@1,R@0
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	CALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __GETD1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X+
	LD   R22,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	CALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __GETBRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	LD   R@0,X
	.ENDM

	.MACRO __GETWRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	LD   R@0,X+
	LD   R@1,X
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __CLRD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R30
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	ST   Z,R@0
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

;NAME DEFINITIONS FOR GLOBAL VARIABLES ALLOCATED TO REGISTERS
	.DEF _a=R5
	.DEF _i=R6
	.DEF __lcd_x=R4
	.DEF __lcd_y=R9
	.DEF __lcd_maxx=R8

	.CSEG
	.ORG 0x00

;START OF CODE MARKER
__START_OF_CODE:

;INTERRUPT VECTORS
	JMP  __RESET
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00

_tbl10_G102:
	.DB  0x10,0x27,0xE8,0x3,0x64,0x0,0xA,0x0
	.DB  0x1,0x0
_tbl16_G102:
	.DB  0x0,0x10,0x0,0x1,0x10,0x0,0x1,0x0

;REGISTER BIT VARIABLES INITIALIZATION
__REG_BIT_VARS:
	.DW  0x0001

_0x29:
	.DB  0x0,0x3
_0x2A:
	.DB  0x20,0x27
_0x0:
	.DB  0x73,0x65,0x61,0x72,0x63,0x68,0x69,0x6E
	.DB  0x67,0x20,0x6D,0x6D,0x63,0x0,0x63,0x61
	.DB  0x72,0x64,0x20,0x64,0x65,0x74,0x65,0x63
	.DB  0x74,0x20,0x6F,0x6B,0x0,0x53,0x65,0x61
	.DB  0x72,0x63,0x68,0x69,0x6E,0x67,0x0,0x6D
	.DB  0x75,0x73,0x69,0x63,0x20,0x70,0x6C,0x61
	.DB  0x79,0x65,0x72,0x0,0x70,0x72,0x65,0x73
	.DB  0x73,0x20,0x70,0x6C,0x61,0x79,0x20,0x6B
	.DB  0x65,0x79,0x0,0x20,0x6D,0x75,0x73,0x69
	.DB  0x63,0x20,0x70,0x6C,0x61,0x79,0x65,0x72
	.DB  0x0,0x70,0x6C,0x61,0x79,0x69,0x6E,0x67
	.DB  0x0,0x70,0x61,0x75,0x73,0x65,0x0,0x20
	.DB  0x20,0x6D,0x75,0x73,0x69,0x63,0x20,0x70
	.DB  0x6C,0x61,0x79,0x65,0x72,0x0,0x62,0x65
	.DB  0x20,0x6B,0x61,0x6C,0x61,0x6D,0x0,0x70
	.DB  0x6C,0x61,0x79,0x69,0x6E,0x67,0x20,0x32
	.DB  0x3A,0x34,0x38,0x0,0x70,0x61,0x72,0x61
	.DB  0x6E,0x64,0x65,0x68,0x0,0x70,0x6C,0x61
	.DB  0x79,0x69,0x6E,0x67,0x20,0x33,0x3A,0x31
	.DB  0x38,0x0,0x64,0x65,0x6C,0x61,0x6D,0x20
	.DB  0x67,0x65,0x72,0x65,0x66,0x74,0x65,0x0
	.DB  0x70,0x6C,0x61,0x79,0x69,0x6E,0x67,0x20
	.DB  0x33,0x3A,0x34,0x33,0x0,0x62,0x65,0x68
	.DB  0x65,0x73,0x68,0x20,0x62,0x65,0x67,0x69
	.DB  0x6E,0x0,0x70,0x6C,0x61,0x79,0x69,0x6E
	.DB  0x67,0x20,0x31,0x3A,0x31,0x39,0x0,0x76
	.DB  0x65,0x6E,0x6F,0x75,0x73,0x65,0x20,0x7A
	.DB  0x69,0x62,0x61,0x0,0x70,0x6C,0x61,0x79
	.DB  0x69,0x6E,0x67,0x20,0x34,0x3A,0x33,0x32
	.DB  0x0,0x69,0x62,0x6F,0x20,0x61,0x6C,0x6C
	.DB  0x61,0x68,0x20,0x61,0x6C,0x6C,0x61,0x68
	.DB  0x0,0x70,0x6C,0x61,0x79,0x69,0x6E,0x67
	.DB  0x20,0x33,0x3A,0x33,0x38,0x0,0x61,0x68
	.DB  0x20,0x6B,0x65,0x73,0x68,0x6B,0x61,0x6D
	.DB  0x20,0x0
_0x2000003:
	.DB  0x80,0xC0

__GLOBAL_INI_TBL:
	.DW  0x01
	.DW  0x02
	.DW  __REG_BIT_VARS*2

	.DW  0x02
	.DW  _m_begin
	.DW  _0x29*2

	.DW  0x02
	.DW  _m_end
	.DW  _0x2A*2

	.DW  0x02
	.DW  __base_y_G100
	.DW  _0x2000003*2

_0xFFFFFFFF:
	.DW  0

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  GICR,R31
	OUT  GICR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,(14-2)+1
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(__CLEAR_SRAM_SIZE)
	LDI  R25,HIGH(__CLEAR_SRAM_SIZE)
	LDI  R26,__SRAM_START
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;HARDWARE STACK POINTER INITIALIZATION
	LDI  R30,LOW(__SRAM_END-__HEAP_SIZE)
	OUT  SPL,R30
	LDI  R30,HIGH(__SRAM_END-__HEAP_SIZE)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(__SRAM_START+__DSTACK_SIZE)
	LDI  R29,HIGH(__SRAM_START+__DSTACK_SIZE)

	JMP  _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x260

	.CSEG
;#include <mega32.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
;#include <alcd.h>
;#include <delay.h>
;#include <spi.h>
;#include <stdio.h>
;#include "mmclib/mmc.h"

	.CSEG
_mmc_command:
	CALL __PUTPARD2
	ST   -Y,R17
	ST   -Y,R16
;	cmd -> Y+6
;	arg -> Y+2
;	resp -> R17
;	retry -> R16
	LDI  R16,0
	CBI  0x18,0
	LDD  R30,Y+6
	ORI  R30,0x40
	CALL SUBOPT_0x0
	LDI  R30,LOW(24)
	CALL __LSRD12
	MOV  R26,R30
	CALL _spi
	__GETD1S 2
	CALL __LSRD16
	CALL SUBOPT_0x0
	LDI  R30,LOW(8)
	CALL __LSRD12
	MOV  R26,R30
	CALL _spi
	LDD  R26,Y+2
	CALL _spi
	LDI  R26,LOW(149)
	CALL _spi
_0x5:
	LDI  R26,LOW(255)
	CALL _spi
	MOV  R17,R30
	CPI  R30,LOW(0xFF)
	BRNE _0x7
	MOV  R26,R16
	SUBI R16,-1
	CPI  R26,LOW(0x9)
	BRLO _0x5
_0x7:
	MOV  R30,R17
	LDD  R17,Y+1
	LDD  R16,Y+0
	ADIW R28,7
	RET
_mmc_init:
	CALL __SAVELOCR4
;	retry -> R17
;	i -> R16
;	resp -> R19
	LDI  R19,0
	LDI  R17,LOW(0)
_0xA:
	LDI  R16,LOW(0)
_0xD:
	CPI  R16,100
	BRSH _0xE
	LDI  R26,LOW(255)
	CALL _spi
	SUBI R16,-1
	RJMP _0xD
_0xE:
	LDI  R30,LOW(0)
	CALL SUBOPT_0x1
	SUBI R17,-1
	CPI  R17,11
	BRLO _0xF
	LDI  R30,LOW(255)
	RJMP _0x20A0003
_0xF:
	CPI  R19,1
	BRNE _0xA
	LDI  R17,LOW(0)
_0x11:
	LDI  R30,LOW(1)
	CALL SUBOPT_0x1
	LDI  R26,LOW(5)
	CALL SUBOPT_0x2
	SUBI R17,-1
	CPI  R17,101
	BRLO _0x13
	LDI  R30,LOW(255)
	RJMP _0x20A0003
_0x13:
	CPI  R19,0
	BRNE _0x11
	LDI  R30,LOW(59)
	CALL SUBOPT_0x1
	LDI  R30,LOW(16)
	ST   -Y,R30
	__GETD2N 0x200
	RCALL _mmc_command
	MOV  R19,R30
	LDI  R26,LOW(10)
	CALL SUBOPT_0x2
	LDI  R30,LOW(0)
_0x20A0003:
	CALL __LOADLOCR4
	ADIW R28,4
	RET
_mmc_read:
	ST   -Y,R27
	ST   -Y,R26
	CALL __SAVELOCR4
;	sector -> Y+6
;	*buffer -> Y+4
;	resp -> R17
;	i -> R18,R19
	CBI  0x18,0
	LDI  R30,LOW(17)
	ST   -Y,R30
	__GETD2S 7
	LDI  R30,LOW(9)
	CALL __LSLD12
	MOVW R26,R30
	MOVW R24,R22
	RCALL _mmc_command
	MOV  R17,R30
	CPI  R17,0
	BREQ _0x16
	MOV  R30,R17
	RJMP _0x20A0002
_0x16:
_0x17:
	LDI  R26,LOW(255)
	CALL _spi
	CPI  R30,LOW(0xFE)
	BRNE _0x17
	__GETWRN 18,19,0
_0x1B:
	__CPWRN 18,19,512
	BRSH _0x1C
	LDD  R30,Y+4
	LDD  R31,Y+4+1
	ADIW R30,1
	STD  Y+4,R30
	STD  Y+4+1,R31
	SBIW R30,1
	PUSH R31
	PUSH R30
	LDI  R26,LOW(255)
	CALL _spi
	POP  R26
	POP  R27
	ST   X,R30
	__ADDWRN 18,19,1
	RJMP _0x1B
_0x1C:
	LDI  R26,LOW(255)
	CALL _spi
	LDI  R26,LOW(255)
	CALL _spi
	LDI  R30,LOW(0)
_0x20A0002:
	CALL __LOADLOCR4
	ADIW R28,10
	RET
;	sector -> Y+6
;	*buffer -> Y+4
;	resp -> R17
;	i -> R18,R19
;void m_play(void);
;void m_next(void);
;void m_pause(void);
;void m_back(void);
;
;char buffread[512];
;char a;
;bit s=1;
;int i;
;unsigned long int m_begin=768,m_end=10016;

	.DSEG
;void main(void){
; 0000 0011 void main(void){

	.CSEG
_main:
; 0000 0012 
; 0000 0013 DDRB=(1<<DDB0)|(1<<DDB4)|(1<<DDB5)|(1<<DDB7)|(1<<DDB3);
	LDI  R30,LOW(185)
	OUT  0x17,R30
; 0000 0014 DDRC=0X00;
	LDI  R30,LOW(0)
	OUT  0x14,R30
; 0000 0015 PORTC=0XFF;
	LDI  R30,LOW(255)
	OUT  0x15,R30
; 0000 0016 SPCR=0x50;
	LDI  R30,LOW(80)
	OUT  0xD,R30
; 0000 0017 SPSR=0x01;
	LDI  R30,LOW(1)
	OUT  0xE,R30
; 0000 0018 TCCR0=0x00;// TCCR0=0x00//TCCR0=0x69
	LDI  R30,LOW(0)
	OUT  0x33,R30
; 0000 0019 TCNT0=0x00;
	OUT  0x32,R30
; 0000 001A OCR0=0x00;
	OUT  0x3C,R30
; 0000 001B TIMSK=0x00;
	OUT  0x39,R30
; 0000 001C lcd_init(16);
	LDI  R26,LOW(16)
	RCALL _lcd_init
; 0000 001D 
; 0000 001E    while(s==1){
_0x2B:
	SBRS R2,0
	RJMP _0x2D
; 0000 001F      s=mmc_init();
	RCALL _mmc_init
	CALL __BSTB1
	BLD  R2,0
; 0000 0020      lcd_gotoxy(0,0);
	CALL SUBOPT_0x3
; 0000 0021      lcd_putsf("searching mmc");
	__POINTW2FN _0x0,0
	RCALL _lcd_putsf
; 0000 0022      }
	RJMP _0x2B
_0x2D:
; 0000 0023    lcd_clear();
	CALL SUBOPT_0x4
; 0000 0024    lcd_gotoxy(0,0);
; 0000 0025    lcd_putsf("card detect ok");
	__POINTW2FN _0x0,14
	RCALL _lcd_putsf
; 0000 0026    delay_ms(20);
	LDI  R26,LOW(20)
	CALL SUBOPT_0x2
; 0000 0027    lcd_clear();
	CALL SUBOPT_0x4
; 0000 0028    lcd_gotoxy(0,0);
; 0000 0029    lcd_putsf("Searching");
	__POINTW2FN _0x0,29
	CALL SUBOPT_0x5
; 0000 002A    delay_us(20);
; 0000 002B    lcd_gotoxy(0,1);
; 0000 002C    lcd_putsf("music player");
	__POINTW2FN _0x0,39
	RCALL _lcd_putsf
; 0000 002D    delay_ms(100);
	LDI  R26,LOW(100)
	CALL SUBOPT_0x2
; 0000 002E  while(1){
_0x2E:
; 0000 002F    lcd_clear();
	CALL SUBOPT_0x4
; 0000 0030    lcd_gotoxy(0,0);
; 0000 0031    lcd_putsf("press play key");
	__POINTW2FN _0x0,52
	CALL SUBOPT_0x5
; 0000 0032    delay_us(20);
; 0000 0033    lcd_gotoxy(0,1);
; 0000 0034    lcd_putsf(" music player");
	__POINTW2FN _0x0,67
	RCALL _lcd_putsf
; 0000 0035 
; 0000 0036   if(PINC.0==0){
	SBIC 0x13,0
	RJMP _0x31
; 0000 0037   while(PINC.0==0);
_0x32:
	SBIS 0x13,0
	RJMP _0x32
; 0000 0038   m_play();
	RCALL _m_play
; 0000 0039   }
; 0000 003A 
; 0000 003B    }
_0x31:
	RJMP _0x2E
; 0000 003C 
; 0000 003D }
_0x35:
	RJMP _0x35
;////////////////////////////////////////////
; void m_play(void){
; 0000 003F void m_play(void){
_m_play:
; 0000 0040  TCCR0=0x69;
	LDI  R30,LOW(105)
	OUT  0x33,R30
; 0000 0041  lcd_clear();
	CALL SUBOPT_0x4
; 0000 0042  lcd_gotoxy(0,0);
; 0000 0043  lcd_putsf("playing");
	__POINTW2FN _0x0,81
	CALL SUBOPT_0x5
; 0000 0044  delay_us(20);
; 0000 0045  lcd_gotoxy(0,1);
; 0000 0046  lcd_putsf("music player");
	__POINTW2FN _0x0,39
	RCALL _lcd_putsf
; 0000 0047     while(1){
_0x36:
; 0000 0048    mmc_read(m_begin,buffread);
	LDS  R30,_m_begin
	LDS  R31,_m_begin+1
	LDS  R22,_m_begin+2
	LDS  R23,_m_begin+3
	CALL __PUTPARD1
	LDI  R26,LOW(_buffread)
	LDI  R27,HIGH(_buffread)
	RCALL _mmc_read
; 0000 0049        for(i=0;i<512;i++){
	CLR  R6
	CLR  R7
_0x3A:
	LDI  R30,LOW(512)
	LDI  R31,HIGH(512)
	CP   R6,R30
	CPC  R7,R31
	BRGE _0x3B
; 0000 004A 
; 0000 004B        while(!(TIFR&0X02));
_0x3C:
	IN   R30,0x38
	ANDI R30,LOW(0x2)
	BREQ _0x3C
; 0000 004C        TIFR |=0X02;
	IN   R30,0x38
	ORI  R30,2
	OUT  0x38,R30
; 0000 004D        OCR0=buffread[i];
	LDI  R26,LOW(_buffread)
	LDI  R27,HIGH(_buffread)
	ADD  R26,R6
	ADC  R27,R7
	LD   R30,X
	OUT  0x3C,R30
; 0000 004E         if(PINC.0==0){
	SBIC 0x13,0
	RJMP _0x3F
; 0000 004F         while(PINC.0==0);
_0x40:
	SBIS 0x13,0
	RJMP _0x40
; 0000 0050         delay_ms(35);
	LDI  R26,LOW(35)
	CALL SUBOPT_0x2
; 0000 0051         m_pause();
	RCALL _m_pause
; 0000 0052         }
; 0000 0053         if(PINC.1==0){
_0x3F:
	SBIC 0x13,1
	RJMP _0x43
; 0000 0054         while(PINC.1==0);
_0x44:
	SBIS 0x13,1
	RJMP _0x44
; 0000 0055         delay_ms(30);
	LDI  R26,LOW(30)
	CALL SUBOPT_0x2
; 0000 0056         m_next();
	RCALL _m_next
; 0000 0057         }
; 0000 0058         if(PINC.2==0){
_0x43:
	SBIC 0x13,2
	RJMP _0x47
; 0000 0059         while(PINC.2==0);
_0x48:
	SBIS 0x13,2
	RJMP _0x48
; 0000 005A         delay_ms(30);
	LDI  R26,LOW(30)
	CALL SUBOPT_0x2
; 0000 005B         m_back();
	RCALL _m_back
; 0000 005C         }
; 0000 005D 
; 0000 005E 
; 0000 005F       }
_0x47:
	MOVW R30,R6
	ADIW R30,1
	MOVW R6,R30
	RJMP _0x3A
_0x3B:
; 0000 0060    m_begin++;
	LDI  R26,LOW(_m_begin)
	LDI  R27,HIGH(_m_begin)
	CALL __GETD1P_INC
	__SUBD1N -1
	CALL __PUTDP1_DEC
; 0000 0061    if(m_begin==m_end) m_next();
	LDS  R30,_m_end
	LDS  R31,_m_end+1
	LDS  R22,_m_end+2
	LDS  R23,_m_end+3
	LDS  R26,_m_begin
	LDS  R27,_m_begin+1
	LDS  R24,_m_begin+2
	LDS  R25,_m_begin+3
	CALL __CPD12
	BRNE _0x4B
	RCALL _m_next
; 0000 0062 
; 0000 0063    }
_0x4B:
	RJMP _0x36
; 0000 0064 
; 0000 0065  }
; //////////////////////////////////
;  void m_pause(void){
; 0000 0067 void m_pause(void){
_m_pause:
; 0000 0068   TCCR0=0x00;
	LDI  R30,LOW(0)
	OUT  0x33,R30
; 0000 0069   lcd_clear();
	CALL SUBOPT_0x4
; 0000 006A   lcd_gotoxy(0,0);
; 0000 006B   lcd_putsf("pause");
	__POINTW2FN _0x0,89
	CALL SUBOPT_0x5
; 0000 006C   delay_us(20);
; 0000 006D   lcd_gotoxy(0,1);
; 0000 006E   lcd_putsf("  music player");
	__POINTW2FN _0x0,95
	RCALL _lcd_putsf
; 0000 006F      while(1){
_0x4C:
; 0000 0070      if(PINC.0==0){
	SBIC 0x13,0
	RJMP _0x4F
; 0000 0071      while(PINC.0==0);
_0x50:
	SBIS 0x13,0
	RJMP _0x50
; 0000 0072      delay_ms(30);
	LDI  R26,LOW(30)
	CALL SUBOPT_0x2
; 0000 0073      m_play();
	RCALL _m_play
; 0000 0074      }
; 0000 0075   }
_0x4F:
	RJMP _0x4C
; 0000 0076  }
;
; ///////////////////////////////////////
;      void m_next(void){
; 0000 0079 void m_next(void){
_m_next:
; 0000 007A       a++;
	INC  R5
; 0000 007B       if(a==8) a=1;
	LDI  R30,LOW(8)
	CP   R30,R5
	BRNE _0x53
	LDI  R30,LOW(1)
	MOV  R5,R30
; 0000 007C 
; 0000 007D        switch(a){
_0x53:
	CALL SUBOPT_0x6
; 0000 007E        case 1:  m_begin=768;m_end=10016;lcd_clear();lcd_putsf("be kalam");lcd_gotoxy(0,1);lcd_putsf("playing 2:48");break;
	BREQ _0x6B
; 0000 007F        case 2:  m_begin=768;m_end=10016;lcd_clear();lcd_putsf("parandeh");lcd_gotoxy(0,1);lcd_putsf("playing 3:18");break;
	CPI  R30,LOW(0x2)
	LDI  R26,HIGH(0x2)
	CPC  R31,R26
	BRNE _0x58
	CALL SUBOPT_0x7
	CALL SUBOPT_0x8
	RJMP _0x6C
; 0000 0080        case 3:  m_begin=768;m_end=10016;lcd_clear();lcd_putsf("delam gerefte");lcd_gotoxy(0,1);lcd_putsf("playing 3:43");break;
_0x58:
	CPI  R30,LOW(0x3)
	LDI  R26,HIGH(0x3)
	CPC  R31,R26
	BRNE _0x59
	CALL SUBOPT_0x7
	CALL SUBOPT_0x9
	RJMP _0x6C
; 0000 0081        case 4:  m_begin=768;m_end=10016;lcd_clear();lcd_putsf("behesh begin");lcd_gotoxy(0,1);lcd_putsf("playing 1:19");break;
_0x59:
	CPI  R30,LOW(0x4)
	LDI  R26,HIGH(0x4)
	CPC  R31,R26
	BRNE _0x5A
	CALL SUBOPT_0x7
	CALL SUBOPT_0xA
	RJMP _0x6C
; 0000 0082        case 5:  m_begin=768;m_end=10016;lcd_clear();lcd_putsf("venouse ziba");lcd_gotoxy(0,1);lcd_putsf("playing 4:32");break;
_0x5A:
	CPI  R30,LOW(0x5)
	LDI  R26,HIGH(0x5)
	CPC  R31,R26
	BRNE _0x5B
	CALL SUBOPT_0x7
	CALL SUBOPT_0xB
	RJMP _0x6C
; 0000 0083        case 6:  m_begin=768;m_end=10016;lcd_clear();lcd_putsf("ibo allah allah");lcd_gotoxy(0,1);lcd_putsf("playing 3:38");break;
_0x5B:
	CPI  R30,LOW(0x6)
	LDI  R26,HIGH(0x6)
	CPC  R31,R26
	BRNE _0x5C
	CALL SUBOPT_0x7
	CALL SUBOPT_0xC
	RJMP _0x6C
; 0000 0084        case 7:  m_begin=768;m_end=10016;lcd_clear();lcd_putsf("ah keshkam ");lcd_gotoxy(0,1);lcd_putsf("playing 4:32");break;
_0x5C:
	CPI  R30,LOW(0x7)
	LDI  R26,HIGH(0x7)
	CPC  R31,R26
	BRNE _0x5E
	CALL SUBOPT_0x7
	CALL SUBOPT_0xD
	RJMP _0x6C
; 0000 0085        default: m_begin=768;m_end=10016;lcd_clear();lcd_putsf("be kalam");lcd_gotoxy(0,1);lcd_putsf("playing 2:48");
_0x5E:
_0x6B:
	__GETD1N 0x300
	CALL SUBOPT_0xE
_0x6C:
	RCALL _lcd_putsf
; 0000 0086          }
; 0000 0087 
; 0000 0088       }
	RET
;
;
;    void m_back(void){
; 0000 008B void m_back(void){
_m_back:
; 0000 008C         a--;
	DEC  R5
; 0000 008D         if(a==0) a=1;
	TST  R5
	BRNE _0x5F
	LDI  R30,LOW(1)
	MOV  R5,R30
; 0000 008E        switch(a){
_0x5F:
	CALL SUBOPT_0x6
; 0000 008F        case 1:  m_begin=768;m_end=10016;lcd_clear();lcd_putsf("be kalam");lcd_gotoxy(0,1);lcd_putsf("playing 2:48");break;
	BREQ _0x6D
; 0000 0090        case 2:  m_begin=768;m_end=10016;lcd_clear();lcd_putsf("parandeh");lcd_gotoxy(0,1);lcd_putsf("playing 3:18");break;
	CPI  R30,LOW(0x2)
	LDI  R26,HIGH(0x2)
	CPC  R31,R26
	BRNE _0x64
	CALL SUBOPT_0x7
	CALL SUBOPT_0x8
	RJMP _0x6E
; 0000 0091        case 3:  m_begin=768;m_end=10016;lcd_clear();lcd_putsf("delam gerefte");lcd_gotoxy(0,1);lcd_putsf("playing 3:43");break;
_0x64:
	CPI  R30,LOW(0x3)
	LDI  R26,HIGH(0x3)
	CPC  R31,R26
	BRNE _0x65
	CALL SUBOPT_0x7
	CALL SUBOPT_0x9
	RJMP _0x6E
; 0000 0092        case 4:  m_begin=768;m_end=10016;lcd_clear();lcd_putsf("behesh begin");lcd_gotoxy(0,1);lcd_putsf("playing 1:19");break;
_0x65:
	CPI  R30,LOW(0x4)
	LDI  R26,HIGH(0x4)
	CPC  R31,R26
	BRNE _0x66
	CALL SUBOPT_0x7
	CALL SUBOPT_0xA
	RJMP _0x6E
; 0000 0093        case 5:  m_begin=768;m_end=10016;lcd_clear();lcd_putsf("venouse ziba");lcd_gotoxy(0,1);lcd_putsf("playing 4:32");break;
_0x66:
	CPI  R30,LOW(0x5)
	LDI  R26,HIGH(0x5)
	CPC  R31,R26
	BRNE _0x67
	CALL SUBOPT_0x7
	CALL SUBOPT_0xB
	RJMP _0x6E
; 0000 0094        case 6:  m_begin=768;m_end=10016;lcd_clear();lcd_putsf("ibo allah allah");lcd_gotoxy(0,1);lcd_putsf("playing 3:38");break;
_0x67:
	CPI  R30,LOW(0x6)
	LDI  R26,HIGH(0x6)
	CPC  R31,R26
	BRNE _0x68
	CALL SUBOPT_0x7
	CALL SUBOPT_0xC
	RJMP _0x6E
; 0000 0095        case 7:  m_begin=768;m_end=10016;lcd_clear();lcd_putsf("ah keshkam ");lcd_gotoxy(0,1);lcd_putsf("playing 4:32");break;
_0x68:
	CPI  R30,LOW(0x7)
	LDI  R26,HIGH(0x7)
	CPC  R31,R26
	BRNE _0x6A
	CALL SUBOPT_0x7
	CALL SUBOPT_0xD
	RJMP _0x6E
; 0000 0096        default: m_begin=768;m_end=10016;lcd_clear();lcd_putsf("be kalam");lcd_gotoxy(0,1);lcd_putsf("playing 2:48");
_0x6A:
_0x6D:
	__GETD1N 0x300
	CALL SUBOPT_0xE
_0x6E:
	RCALL _lcd_putsf
; 0000 0097          }
; 0000 0098 
; 0000 0099 
; 0000 009A 
; 0000 009B     }
	RET
;
;
;
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif

	.DSEG

	.CSEG
__lcd_write_nibble_G100:
	ST   -Y,R26
	IN   R30,0x12
	ANDI R30,LOW(0xF)
	MOV  R26,R30
	LD   R30,Y
	ANDI R30,LOW(0xF0)
	OR   R30,R26
	OUT  0x12,R30
	__DELAY_USB 5
	SBI  0x12,2
	__DELAY_USB 13
	CBI  0x12,2
	__DELAY_USB 13
	RJMP _0x20A0001
__lcd_write_data:
	ST   -Y,R26
	LD   R26,Y
	RCALL __lcd_write_nibble_G100
    ld    r30,y
    swap  r30
    st    y,r30
	LD   R26,Y
	RCALL __lcd_write_nibble_G100
	__DELAY_USB 133
	RJMP _0x20A0001
_lcd_gotoxy:
	ST   -Y,R26
	LD   R30,Y
	LDI  R31,0
	SUBI R30,LOW(-__base_y_G100)
	SBCI R31,HIGH(-__base_y_G100)
	LD   R30,Z
	LDD  R26,Y+1
	ADD  R26,R30
	RCALL __lcd_write_data
	LDD  R4,Y+1
	LDD  R9,Y+0
	ADIW R28,2
	RET
_lcd_clear:
	LDI  R26,LOW(2)
	RCALL __lcd_write_data
	LDI  R26,LOW(3)
	CALL SUBOPT_0x2
	LDI  R26,LOW(12)
	RCALL __lcd_write_data
	LDI  R26,LOW(1)
	RCALL __lcd_write_data
	LDI  R26,LOW(3)
	CALL SUBOPT_0x2
	LDI  R30,LOW(0)
	MOV  R9,R30
	MOV  R4,R30
	RET
_lcd_putchar:
	ST   -Y,R26
	LD   R26,Y
	CPI  R26,LOW(0xA)
	BREQ _0x2000005
	CP   R4,R8
	BRLO _0x2000004
_0x2000005:
	LDI  R30,LOW(0)
	ST   -Y,R30
	INC  R9
	MOV  R26,R9
	RCALL _lcd_gotoxy
	LD   R26,Y
	CPI  R26,LOW(0xA)
	BRNE _0x2000007
	RJMP _0x20A0001
_0x2000007:
_0x2000004:
	INC  R4
	SBI  0x12,0
	LD   R26,Y
	RCALL __lcd_write_data
	CBI  0x12,0
	RJMP _0x20A0001
_lcd_putsf:
	ST   -Y,R27
	ST   -Y,R26
	ST   -Y,R17
_0x200000B:
	LDD  R30,Y+1
	LDD  R31,Y+1+1
	ADIW R30,1
	STD  Y+1,R30
	STD  Y+1+1,R31
	SBIW R30,1
	LPM  R30,Z
	MOV  R17,R30
	CPI  R30,0
	BREQ _0x200000D
	MOV  R26,R17
	RCALL _lcd_putchar
	RJMP _0x200000B
_0x200000D:
	LDD  R17,Y+0
	ADIW R28,3
	RET
_lcd_init:
	ST   -Y,R26
	IN   R30,0x11
	ORI  R30,LOW(0xF0)
	OUT  0x11,R30
	SBI  0x11,2
	SBI  0x11,0
	SBI  0x11,1
	CBI  0x12,2
	CBI  0x12,0
	CBI  0x12,1
	LDD  R8,Y+0
	LD   R30,Y
	SUBI R30,-LOW(128)
	__PUTB1MN __base_y_G100,2
	LD   R30,Y
	SUBI R30,-LOW(192)
	__PUTB1MN __base_y_G100,3
	LDI  R26,LOW(20)
	CALL SUBOPT_0x2
	CALL SUBOPT_0xF
	CALL SUBOPT_0xF
	CALL SUBOPT_0xF
	LDI  R26,LOW(32)
	RCALL __lcd_write_nibble_G100
	__DELAY_USW 200
	LDI  R26,LOW(40)
	RCALL __lcd_write_data
	LDI  R26,LOW(4)
	RCALL __lcd_write_data
	LDI  R26,LOW(133)
	RCALL __lcd_write_data
	LDI  R26,LOW(6)
	RCALL __lcd_write_data
	RCALL _lcd_clear
	RJMP _0x20A0001
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif

	.CSEG
_spi:
	ST   -Y,R26
	LD   R30,Y
	OUT  0xF,R30
_0x2020003:
	SBIS 0xE,7
	RJMP _0x2020003
	IN   R30,0xF
_0x20A0001:
	ADIW R28,1
	RET
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif

	.CSEG

	.CSEG

	.CSEG

	.DSEG
_buffread:
	.BYTE 0x200
_m_begin:
	.BYTE 0x4
_m_end:
	.BYTE 0x4
__base_y_G100:
	.BYTE 0x4

	.CSEG
;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x0:
	MOV  R26,R30
	CALL _spi
	__GETD2S 2
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x1:
	ST   -Y,R30
	__GETD2N 0x0
	CALL _mmc_command
	MOV  R19,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 11 TIMES, CODE SIZE REDUCTION:27 WORDS
SUBOPT_0x2:
	LDI  R27,0
	JMP  _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:12 WORDS
SUBOPT_0x3:
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R26,LOW(0)
	JMP  _lcd_gotoxy

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x4:
	CALL _lcd_clear
	RJMP SUBOPT_0x3

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:21 WORDS
SUBOPT_0x5:
	CALL _lcd_putsf
	__DELAY_USB 53
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R26,LOW(1)
	JMP  _lcd_gotoxy

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x6:
	MOV  R30,R5
	LDI  R31,0
	CPI  R30,LOW(0x1)
	LDI  R26,HIGH(0x1)
	CPC  R31,R26
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 12 TIMES, CODE SIZE REDUCTION:261 WORDS
SUBOPT_0x7:
	__GETD1N 0x300
	STS  _m_begin,R30
	STS  _m_begin+1,R31
	STS  _m_begin+2,R22
	STS  _m_begin+3,R23
	__GETD1N 0x2720
	STS  _m_end,R30
	STS  _m_end+1,R31
	STS  _m_end+2,R22
	STS  _m_end+3,R23
	JMP  _lcd_clear

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x8:
	__POINTW2FN _0x0,132
	CALL _lcd_putsf
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R26,LOW(1)
	CALL _lcd_gotoxy
	__POINTW2FN _0x0,141
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x9:
	__POINTW2FN _0x0,154
	CALL _lcd_putsf
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R26,LOW(1)
	CALL _lcd_gotoxy
	__POINTW2FN _0x0,168
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0xA:
	__POINTW2FN _0x0,181
	CALL _lcd_putsf
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R26,LOW(1)
	CALL _lcd_gotoxy
	__POINTW2FN _0x0,194
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0xB:
	__POINTW2FN _0x0,207
	CALL _lcd_putsf
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R26,LOW(1)
	CALL _lcd_gotoxy
	__POINTW2FN _0x0,220
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0xC:
	__POINTW2FN _0x0,233
	CALL _lcd_putsf
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R26,LOW(1)
	CALL _lcd_gotoxy
	__POINTW2FN _0x0,249
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0xD:
	__POINTW2FN _0x0,262
	CALL _lcd_putsf
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R26,LOW(1)
	CALL _lcd_gotoxy
	__POINTW2FN _0x0,220
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:28 WORDS
SUBOPT_0xE:
	STS  _m_begin,R30
	STS  _m_begin+1,R31
	STS  _m_begin+2,R22
	STS  _m_begin+3,R23
	__GETD1N 0x2720
	STS  _m_end,R30
	STS  _m_end+1,R31
	STS  _m_end+2,R22
	STS  _m_end+3,R23
	CALL _lcd_clear
	__POINTW2FN _0x0,110
	CALL _lcd_putsf
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R26,LOW(1)
	CALL _lcd_gotoxy
	__POINTW2FN _0x0,119
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0xF:
	LDI  R26,LOW(48)
	CALL __lcd_write_nibble_G100
	__DELAY_USW 200
	RET


	.CSEG
_delay_ms:
	adiw r26,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0x7D0
	wdr
	sbiw r26,1
	brne __delay_ms0
__delay_ms1:
	ret

__LSLD12:
	TST  R30
	MOV  R0,R30
	MOVW R30,R26
	MOVW R22,R24
	BREQ __LSLD12R
__LSLD12L:
	LSL  R30
	ROL  R31
	ROL  R22
	ROL  R23
	DEC  R0
	BRNE __LSLD12L
__LSLD12R:
	RET

__LSRD12:
	TST  R30
	MOV  R0,R30
	MOVW R30,R26
	MOVW R22,R24
	BREQ __LSRD12R
__LSRD12L:
	LSR  R23
	ROR  R22
	ROR  R31
	ROR  R30
	DEC  R0
	BRNE __LSRD12L
__LSRD12R:
	RET

__LSRD16:
	MOV  R30,R22
	MOV  R31,R23
	LDI  R22,0
	LDI  R23,0
	RET

__GETD1P_INC:
	LD   R30,X+
	LD   R31,X+
	LD   R22,X+
	LD   R23,X+
	RET

__PUTDP1_DEC:
	ST   -X,R23
	ST   -X,R22
	ST   -X,R31
	ST   -X,R30
	RET

__PUTPARD1:
	ST   -Y,R23
	ST   -Y,R22
	ST   -Y,R31
	ST   -Y,R30
	RET

__PUTPARD2:
	ST   -Y,R25
	ST   -Y,R24
	ST   -Y,R27
	ST   -Y,R26
	RET

__CPD12:
	CP   R30,R26
	CPC  R31,R27
	CPC  R22,R24
	CPC  R23,R25
	RET

__BSTB1:
	CLT
	TST  R30
	BREQ PC+2
	SET
	RET

__SAVELOCR4:
	ST   -Y,R19
__SAVELOCR3:
	ST   -Y,R18
__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR4:
	LDD  R19,Y+3
__LOADLOCR3:
	LDD  R18,Y+2
__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

;END OF CODE MARKER
__END_OF_CODE:
